<?php

namespace app\admin\controller;

use app\BaseController;
use think\App;
use think\facade\Db;

class Unit extends BaseController
{
    public $post ="";
    public function __construct(App $app)
    {
        parent::__construct($app);
        $this->post=$this->request->post();
    }
    public function create(){
        $unit = isset($this->post['unit']) && $this->post['unit'] !==""? trim($this->post['unit']):"";
        if($unit==""){
            return error_show(1002,"参数unit不能为空");
        }
        $token = isset($this->post['token'])&&$this->post['token']!='' ? trim($this->post['token']):"";
        if($token==''){
            return error_show(1005,"参数token不能为空");
        }
        $user =GetUserInfo($token);
        if(empty($user)||$user['code']!=0){
            return error_show(1002,"创建人数据不存在");
        }
        $createrid= isset($user["data"]['id']) ?  $user["data"]['id'] : "";
        $creater= isset($user["data"]['nickname']) ?  $user["data"]['nickname'] : "";
        $status = isset($this->post['status']) &&$this->post['status'] !==""? intval($this->post['status']):"1";
        $data=[
            "unit"=>$unit,
            "creater"=>$creater,
            "createrid"=>$createrid,
            "status"=>$status,
            "is_del"=>0,
            "addtime"=>date("Y-m-d H:i:s"),
            "updatetime"=>date("Y-m-d H:i:s")
        ];
        $info = Db::name("unit")->insert($data);
        if($info){
            return error_show(0,"新建成功");
        }else{
            return error_show(1002,"新建失败");
        }
    }
    public function list(){
        $page = isset($this->post['page']) && $this->post['page'] !==""? intval($this->post['page']):"1";
        $size = isset($this->post['size']) && $this->post['size'] !=="" ? intval($this->post['size']):"10";
        $where=[["is_del","=",0]];
        $unit = isset($this->post['unit']) && $this->post['unit'] !=="" ? trim($this->post['unit']):"";
        if($unit!==""){
            $where[]=['unit',"like","%$unit%"];
        }
        $status = isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status'])
            :"";
        if($status!==""){
            $where[]=['status',"=",$status];
        }
        $creater = isset($this->post['creater']) && $this->post['creater'] !=="" ? trim($this->post['creater']):"";
        if($creater!=""){
            $where[]=['creater',"like","%$creater%"];
        }
        $start = isset($this->post['start']) && $this->post['start']!=="" ? $this->post['start']:"";
        if($start!==""){
           // $where[]=['addtime',">=",date('Y-m-d H:i:s')];//,strtotime($start)
            $where[]=['addtime',">=",$start];
        }
        $end = isset($this->post['end']) && $this->post['end']!=="" ? $this->post['end']:"";
        if($end!==""){
           // $where[]=['addtime',"<",date('Y-m-d H:i:s')];//,strtotime($end)+24*3600
            $where[]=['addtime',"<=",$end];
        }
        $count = Db::name('unit') ->where($where)->count();
        $total = ceil($count / $size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name('unit')->where($where)->page($page,$size)->order("addtime desc")->select();
        return app_show(0,"获取成功",['list'=>$list,'count'=>$count]);
    }
    public function edit(){
        $id = isset($this->post['id']) && $this->post['id'] !==""? intval($this->post['id']):"";
        if($id==""){
            return error_show(1002,"参数id不能为空");
        }
        $info = Db::name('unit')->where(['id'=>$id,'is_del'=>0])->find();
        if($info==""){
            return error_show(1003,"未找到数据");
        }
        if($info['status']==1){
            return error_show(1002,"状态是启用状态，无法编辑");
        }
        $unit = isset($this->post['unit']) && $this->post['unit'] !==""? trim($this->post['unit']):"";
        if($unit==""){
            return error_show(1002,"参数unit不能为空");
        }
//        $token = isset($this->post['token'])&&$this->post['token']!='' ? trim($this->post['token']):"";
//        if($token==''){
//            return error_show(1005,"参数token不能为空");
//        }
//        $user =GetUserInfo($token);
//        if(empty($user)||$user['code']!=0){
//            return error_show(1002,"创建人数据不存在");
//        }
//        $createrid= isset($user["data"]['id']) ?  $user["data"]['id'] : "";
//        $creater= isset($user["data"]['nickname']) ?  $user["data"]['nickname'] : "";
        $status = isset($this->post['status']) &&$this->post['status'] !==""? intval($this->post['status']):"0";
        $data=[
            "id"=>$id,
            "unit"=>$unit,
//            "creater"=>$creater,
//            "createrid"=>$createrid,
          // "status"=>$status,
            "is_del"=>0,
            "updatetime"=>date("Y-m-d H:i:s")
        ];
        $datainfo = Db::name('unit')->save($data);
        if($datainfo){
            return error_show(0,"更新成功");
        }else{
            return error_show(1002,"更新失败");
        }
    }
    public function del(){
        $id = $this->post['id'] && $this->post['id'] !=="" ? intval($this->post['id']) :"";
        if($id===""){
            return  error_show(1004,"参数id不能为空");
        }
        $str= Db::name('unit')->where(['id'=>$id,'is_del'=>0])->find();
        if(empty($str)){
            return error_show(1002,"未找到数据");
        }
        $end = Db::name('unit')->update(['id'=>$id,'is_del'=>1]);
        if($end){
            return error_show(0,"删除成功");
        }else{
            return error_show(1002,"删除失败");
        }
    }
    public function status(){
        $id = isset($this->post['id']) && $this->post['id'] !==""? intval($this->post['id']):"";
        if($id==""){
            return error_show(1002,"参数id不能为空");
        }
        $info =  Db::name("unit")->where([["id","=",$id],["is_del","=",0]])->find();
        if(!$info){
            return error_show(1002,"未找到对应数据");
        }
        $status =  isset($this->post['status']) && $this->post['status']!==""? intval($this->post['status']):"";
        if($status===""){
            return error_show(1002,"参数status不能为空");
        }
        if(!in_array($status,[0,1])){
            return error_show(1002,"参数status无效");
        }
        $info['status']=$status;
        $info['updatetime']=date("Y-m-d H:i:s");
        $msg = $status==1?"启用":"禁用";
        $update = Db::name("unit")->save($info);
        return  $update? error_show(0,"{$msg}成功"):error_show(1004,"{$msg}失败");
    }
}